
package net.javainthebox.flickr;

import javafx.data.pull.Event;
import javafx.data.pull.PullParser;
import javafx.io.http.HttpRequest;

import java.io.InputStream;
import java.lang.Exception;

public class AtomReader {
    public-init var url: String;

    // IɃR[R[obN֐
    public var onDone: function(:PhotoInfo[]): Void;

    // TlCURLo߂̐K\
    def pattern = java.util.regex.Pattern.compile("http://farm.*_m.jpg");

    public function read(): Void {
        var request = HttpRequest {
            location: url

            // ͂̉͂parse֐ōs
            onInput: parse

            // G[
            onException: function(ex: Exception) {
                println("exception: {ex.getMessage()}");
            }
        };
        request.enqueue();
    }

    // Atom̃p[X
    function parse(stream: InputStream) {
        var infos: PhotoInfo[];
        var info: PhotoInfo;
        var inEntry: Boolean;

        var parser = PullParser {
            documentType: PullParser.XML;
            input: stream
            
            onEvent: function(event: Event) {
                if (event.type == PullParser.START_ELEMENT) {
                    if (event.qname.name == "entry") {
                        // <entry>̊Jn
                        // VPhotoInfoIuWFNg𐶐
                        inEntry = true;
                        info = PhotoInfo {};
                    }
                }
                if (event.type == PullParser.END_ELEMENT) {
                    if (event.qname.name == "entry") {
                        // </entry>̏ꍇ
                        // 쐬PhotoInfoIuWFNgV[PXɒǉ
                        inEntry = false;
                        insert info into infos;
                    } else if (inEntry and event.qname.name == "title") {
                        // </title>̏ꍇ
                        // PhotoInfoIuWFNgtitleݒ
                        info.title = event.text;
                    } else if (inEntry and event.qname.name == "content") {
                        // </content>̏ꍇ
                        // K\pāATlCURLoA
                        // PhotoInfoIuWFNgthumbnailUrlɐݒ
                        var matcher = pattern.matcher(event.text);
                        if (matcher.find()) {
                            var url = matcher.group();
                            info.thumbnailUrl = url.replaceAll("_m", "_t");
                        }
                    }
                }
            }
        }
        // p[X̊Jn
        parser.parse();

        if (onDone != null) {
            // p[XIAR[obN֐R[
            onDone(infos);
        }

        stream.close();
    }
}