
package net.javainthebox.flickrviewer;
 
import javafx.scene.CustomNode;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.effect.Reflection;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.Text;

// C[W\yC
public class ImagePane extends CustomNode {
    public-read var width = 540;
    public-read var height = 660;
 
    // IꂽTlCύXꂽɃR[֐
    public function update(title: String, url: String): Void {
        // C[W
        var image = Image {
            url: url
            // obNOEhŃC[W[h
            backgroundLoading: true
        }
        imageView = ImageView {
            translateX: bind (width - image.width) / 2
            translateY: bind (height - image.height) / 2
             
            // ɃC[W𔽎˂GtFNg
            effect: Reflection {
                fraction: 0.4
            }
            image: image
        }

        // C[W̃^Cg
        label = Text {
            translateX: 10
            translateY: 30

            font: Font {
                size: 18
            }
            fill: Color.WHITE
            content: title
        }
    }

    var imageView: ImageView;
    var label: Text;

    public override function create(): Node {
        Group {
            content: bind [label, imageView]
        }
    }
}