
import javafx.async.AbstractAsyncOperation;

import java.lang.Object;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.TimeUnit;

import com.sun.javafx.runtime.async.AsyncOperationListener;

public class Mandelbrot extends AbstractAsyncOperation {
    // XbhԂŃf[^󂯓nL[
    // XbhZ[tBlockingQueueC^tF[Xgp
    var queue: BlockingQueue;
    
    // 񓯊sJavaNX
    var worker: MandelbrotWorker;

    public override function start(): Void {
        // XbhԂ̌vZʂ̈nɃL[gp
        // BlockingQueueC^tF[X̃RN[gNXƂ
        // LinkedBlockingQueueNXgp
        queue = new LinkedBlockingQueue();

        // Java̔񓯊
        worker = new MandelbrotWorker(queue, listener);
        // 񓯊̊Jn
        worker.start();
    }
 
    public override function cancel(): Void {
        // 񓯊̃LZ
        worker.cancel();
    }

    public override function onCompletion(value: Object): Void {}

    // L[vZʂo
    public function poll(): Point {
        queue.poll() as Point;
    }
}